
(in-ns 'propagator)
(use 'vijual)
(import '(javax.swing JFrame JPanel)
        '(java.awt Color Graphics)
        '(java.awt.image BufferedImage))

;; saving graph information
;; record keeping for graphing propagators
(def prop-graph {})
(defmacro remember-prop [name in-cells out-cells]
  `(def prop-graph
        (assoc prop-graph
          (quote ~name)
          {:in-cells (map (fn [x#] (name x#)) (quote ~in-cells))
           :out-cells (map (fn [x#] (name x#)) (quote ~out-cells))})))

(defmacro propagator "Define a new propagator."
  [name in-cells out-cells & body]
  `(do
     (remember-prop ~name ~in-cells ~out-cells)
     (defn ~(with-meta name
              (assoc (meta name)
                :in-cells in-cells :out-cells out-cells))
       ~in-cells ~@body)
     (doseq [cell# ~in-cells] (add-neighbor cell# ~name))
     ~name))

;; stuff for graphing
(def dim [300 300])

(def frame (JFrame.))

(defn view "Display a graph generated by vijual" [img]
  (let [mult 1.5
        width (* (.getWidth img) mult)
        height (* (.getHeight img) mult)
        offset 50
        panel (doto (proxy [JPanel] []
                      (paint [g]
                             (.drawImage g img offset offset nil))))]
    (doto frame (.add panel) .pack (.setSize (+ offset width) (+ offset height)).show)))

(defn graph-propagators []
  (vec (set
        (apply concat
               (map (fn [key]
                      (let [hsh (get prop-graph key)]
                        (concat
                         (map #(vec (list % (name key))) (get hsh :in-cells))
                         (map #(vec (list (name key) %)) (get hsh :out-cells)))))
                    (keys prop-graph))))))

(defn view-network []
  (view (draw-directed-graph-image (graph-propagators))))

(defn clear-network []
  (def prop-graph {})
  (def frame (JFrame.)))
